package de.towerdefence.server.server;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import com.fasterxml.jackson.databind.node.ObjectNode;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.io.IOException;
import java.util.Map;

import org.springframework.web.socket.TextMessage;
import org.springframework.web.socket.WebSocketSession;


@Getter
@AllArgsConstructor
public abstract class JsonMessage {
    protected abstract String getMessageId();
    protected abstract Map<String, JsonNode> getData(JsonNodeFactory factory);

    public void send(WebSocketSession session) throws IOException {
        session.sendMessage(new TextMessage(getPayload()));
    }

    public String getPayload() {
        JsonNodeFactory factory = new JsonNodeFactory(false);
        ObjectNode msg = factory.objectNode().put("$id", getMessageId());
        for (Map.Entry<String, JsonNode> entry : getData(factory).entrySet()) {
            if(entry.getKey().equals("$id")){
                continue;
            }
            msg.set(entry.getKey(), entry.getValue());
        }
        return msg.toString();
    }
}
