package de.towerdefence.server.server.channels.connection.out;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import de.towerdefence.server.server.JsonMessage;
import de.towerdefence.server.session.Channel;
import lombok.AllArgsConstructor;

import java.util.Map;

@AllArgsConstructor
public class ProvidedConnectionTokenMessage extends JsonMessage {
    private final Channel channel;
    private final String token;

    @Override
    protected String getMessageId() {
        return "ProvidedConnectionToken";
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of(
                "channel", factory.textNode(channel.getJsonName()),
                "token", factory.textNode(token)
        );
    }
}
