package de.towerdefence.server.server.channels.matchmaking.bi;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import de.towerdefence.server.server.JsonMessage;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Map;

@Getter
@NotNull
@AllArgsConstructor
public class MatchSetSearchStateMessage extends JsonMessage {
    public static final String MESSAGE_ID = "MatchSetSearchState";

    @Getter
    @JsonProperty("$id")
    private String messageId;

    private boolean searching;

    public MatchSetSearchStateMessage(boolean searching) {
        this(MESSAGE_ID, searching);
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of(
                "searching", factory.booleanNode(this.searching)
        );
    }
}
