package de.towerdefence.server.server.channels.matchmaking.out;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import de.towerdefence.server.server.JsonMessage;
import lombok.AllArgsConstructor;

import java.util.Map;

@AllArgsConstructor
public class MatchEstablishedMessage extends JsonMessage {
    private String matchId;
    private String opponentName;

    @Override
    protected String getMessageId() {
        return "MatchEstablished";
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of(
                "matchId", factory.textNode(this.matchId),
                "opponentName", factory.textNode(this.opponentName)
        );
    }
}
