package de.towerdefence.server.server.channels.matchmaking.out;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import de.towerdefence.server.server.JsonMessage;
import lombok.AllArgsConstructor;

import java.util.Map;

@AllArgsConstructor
public class MatchFoundMessage extends JsonMessage {
    private String matchId;
    private long created;
    private long ttl;

    @Override
    protected String getMessageId() {
        return "MatchFound";
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of(
                "matchId", factory.textNode(this.matchId),
                "created", factory.numberNode(this.created),
                "ttl", factory.numberNode(this.ttl)
        );
    }
}
