package de.towerdefence.server.server.channels.time;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.JsonNodeFactory;
import de.towerdefence.server.server.JsonMessage;
import lombok.AllArgsConstructor;

import java.util.Map;

@AllArgsConstructor
public class TimeMessage extends JsonMessage {
    private final long time;

    @Override
    protected String getMessageId() {
        return "CurrentUnixTime";
    }

    @Override
    protected Map<String, JsonNode> getData(JsonNodeFactory factory) {
        return Map.of("time", factory.numberNode(this.time));
    }
}
