package de.towerdefence.server.utils;

import de.towerdefence.server.oas.models.AdministratablePlayer;
import de.towerdefence.server.player.Player;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class PlayerMapperService {

    public List<AdministratablePlayer> mapPlayersToAdministratablePlayers(List<Player> players) {
        List<AdministratablePlayer> administratablePlayers = new ArrayList<>();
        for (Player player : players) {
            AdministratablePlayer apiPlayer = new AdministratablePlayer();
            apiPlayer.setUsername(player.getUsername());
            administratablePlayers.add(apiPlayer);
        }
        return administratablePlayers;
    }

    public AdministratablePlayer mapPlayerToAdministratablePlayer(Player player) {
        AdministratablePlayer administratablePlayer = new AdministratablePlayer();
        administratablePlayer.setUsername(player.getUsername());
        return administratablePlayer;
    }
}
